clear all;
gpuDevice(1)
addpath(genpath('./RNN/'))
%%
disp('...Loading data...')
%%
disp('...Slicing data into sequences...')
T = 11; % fixed BPTT length
% you need to supply your train_cell and target cell, each cell entry is a sequence
[train_seq, target_seq] = prepareTrainSeq(train_cell, target_cell, T);
target_seq = target_seq + 1;
clear train_cell target_cell

%%
max_id = 2; % if do classification, this is the number of classes
dim_input = size(train_seq, 2);

opts.net_struct = [dim_input, 256 , max_id];
opts.isRecurrent = [0, 1, 0]; % 1 means the layer is recurrent. No recurrence on input

opts.isGradClip = 1;
opts.spectral_rad = 1.1;
opts.isSpecNorm = 1;
opts.grad_clip_thr = 30;

opts.learner = 'ada_sgd'; % 'ada_sgd' or 'sgd'
opts.sgd_max_epoch = 30;
opts.sgd_batch_size = 256; % batch size for SGD
opts.ada_sgd_scale = 0.0015; % scaling factor for ada_grad
opts.sgd_learn_rate = linspace(0.01, 0.001, opts.sgd_max_epoch); % linearly decreasing lrate for plain sgd

opts.initial_momentum = 0.5;
opts.final_momentum = 0.9;
opts.change_momentum_point = 5;

opts.cost_function = 'softmax_xentropy'; % if want to do classification
opts.unit_type_output = 'softmax';
opts.unit_type_hidden = 'sigm';

opts.isDropout = 0; %
opts.drop_ratio = 0.2;

opts.isGPU = 1;
opts.save_model_path = '~/work/VAD/models/'; % path to save your model

%% //////////////////
opts %#ok<NOPTS>
opts.cv_interval = 1;
tic
net = trainDeepRNN(train_seq, target_seq, test, opts);
toc
net
